* VGA & Mouse test

IF VSYSTEM() != 5
    CLEAR
    ? "This program requires a VGA adaptor"
    ? "Hit any key to quit"
    VINKEY()
    QuitOut()
ENDIF

IF MSE_RSET() != .T.
    ? "Mouse driver and/or Mouse not responding please check and restart"
    ? "Hit any key to quit"
    VINKEY()
    QuitOut()
ENDIF



* Menu Variable
menuchoice = 0

* Video attributes

BLACK                 = 0
BLUE                  = 1
GREEN                 = 2
CYAN                  = 3
RED                   = 4
MAGENTA               = 5
BROWN                 = 6
WHITE                 = 7
GRAY                  = 8
LTBLUE                = 9
LTGREEN               = 10
LTCYAN                = 11
LTRED                 = 12
LTMAGENTA             = 13
YELLOW                = 14
BTWHITE               = 15

* Keyboard/Button

POINT                 = 2000
CURSLEFT              = 19
CURSRIGHT             = 4
HOME                  = 1
END                   = 6
ESC                   = 27
F1                    = 28

* Cursor Off
SET CURSOR OFF

VMODE(19)

* Mouse setup
MSE_RSET()                      && reset it just in case
MSE_SET(1)                      && set mouse routine
MSE_ON()

Calypso()

VMODE(18)                       && set video mode VGA 640 x 480 16 colour

MSE_RSET()                      && reset it just in case
MSE_SET(1)                      && set mouse routine

VCLEARSCR(0, 0, 640, 480)       && clear screen to default colour

MSE_ON()                        && display the mouse

* Mouse /Map coords

PUBLIC mx, my, mapx, mapy, old_mapx, old_mapy, marker, oldmarker

mx         = 0
my         = 0
mapx       = 0
mapy       = 0
old_mapx   = 0
old_mapy   = 0
marker     = REPLICATE(CHR(LTRED), 25)
oldmarker  = SPACE(25)


* button coords

PUBLIC x, y, dx, dy, spacer

x          = 18
y          = 420
dx         = 92
dy         = 30
spacer     = dx + 10

* display area coords

PUBLIC display_x, display_y, display_dx, display_dy

display_x  = 5
display_y  = 50
display_dx = 629
display_dy = y - 80

* Help coords

PUBLIC help_x, help_y, help_dx, help_dy

help_x     = 385
help_y     = 57
help_dx    = 242
help_dy    = display_dy - 22

* image coords

PUBLIC image_x, image_y, image_dx, image_dy

image_x    = 16
image_y    = 60
image_dx   = 359
image_dy   = 179

* Database record coords

PUBLIC rec_x, rec_y, prm_x, prm_y

prm_x = image_x
prm_y = image_dy+image_y + VTHEIGHT()
rec_x = prm_x+VTWIDTH()*13
rec_y = prm_y

* Message coords

PUBLIC messg_x, messg_y

messg_x    = display_x
messg_y    = 398


* open database and display first record

SELECT 1
USE City INDEX Cityname, Longlat
SET SOFTSEEK ON
DisplayScr()                    && display screen
DisplayPrm()                    && display data prompts

* we have to do this once to get oldmarker data
mapy = IF(N_S = "N", image_y+90-INT(LAT), image_y+90+INT(LAT))
mapx = IF(W_E = "W", image_x+180-INT(LONG), image_x+180+INT(LONG))
VCOPYBMP(mapx-2, mapy-2, 5, 5, oldmarker)

DisplayRec()                    && display first record


* wait for menu option

DO WHILE .T.

menuchoice = VINKEY()

VSAY_AT(messg_x, messg_y, "                     ")


  * perform selected option
  DO CASE
    CASE menuchoice =POINT          && mouse click on invisible button
        mx = MSE_PX(0)
        my = MSE_PY(0)
        Pointer()
    CASE menuchoice =ESC            && quit
        QuitOut()
    CASE menuchoice =HOME           && go first
        FirstRec()
        VSAY_AT(messg_x, messg_y, "First Record")
    CASE menuchoice =END            && go last
        EndRec()
        VSAY_AT(messg_x, messg_y, "Last Record")
    CASE menuchoice =CURSLEFT       && previous rec
        PrevRec()
        VSAY_AT(messg_x, messg_y, "Previous Record")
    CASE menuchoice =CURSRIGHT      && next rec
        NextRec()
        VSAY_AT(messg_x, messg_y, "Next Record")
    CASE menuchoice =ASC("?")       && Look up
        LookupRec()
        VSAY_AT(messg_x, messg_y, "Look up Record")
    CASE menuchoice =F1             && Help
        Helpex()

  ENDCASE

ENDDO

QuitOut()


********
** Function : Pointer
********
FUNCTION Pointer

    PRIVATE seekstring, we, ns, longitude, latitude

    SET ORDER TO 2

    we = IF(mx < image_x+180, "W", "E")
    ns = IF(my < image_y+90, "N", "S")

    longitude = IF(mx < image_x+180, 180+image_x-mx, mx-180-image_x)
    latitude  = IF(my < image_y+90, 90+image_y-my, my-90-image_y)

    seekstring = we + ns + TRANSFORM(INT(longitude), "###") + TRANSFORM(INT(latitude), "###")

    SEEK seekstring

    DisplayRec()

RETURN(0)

********
** Function : LookupRec
********
FUNCTION LookupRec

    PRIVATE cityname, oldcolour
    cityname = SPACE(20)

    VSAY_AT(messg_x, messg_y, "Enter city name ")

    oldcolour = VSTXTCOLR(RED)

    VGET_AT(VCOL(), messg_y, cityname)

    VSAY_AT(messg_x, messg_y, SPACE(40))

    cityname = UPPER(cityname)

    VSTXTCOLR(oldcolour)

    SET ORDER TO 1

    SEEK cityname

    DisplayRec()

RETURN(0)

********
** Function : DisplayLoc
********
FUNCTION DisplayLoc

    VDRAWBMP(mapx-2, mapy-2, 5, 5, oldmarker)   && redraw

    mapy = IF(N_S = "N", image_y+90-INT(LAT), image_y+90+INT(LAT))

    mapx = IF(W_E = "W", image_x+180-INT(LONG), image_x+180+INT(LONG))

    VCOPYBMP(mapx-2, mapy-2, 5, 5, oldmarker)   && copy

    VDRAWBMP(mapx-2, mapy-2, 5, 5, marker)      && draw

RETURN(0)

********
** Function : DisplayRec
********
FUNCTION DisplayRec

    PRIVATE m_lat, m_ns, m_long, m_we, m_city, m_country, m_timezone, m_telcode
    PRIVATE m_pop, textheight, textwidth, oldcolour, timesign

    * get values once for speed

    textheight = VTHEIGHT()
    textwidth  = VTWIDTH()

    * set text background colour

    oldcolour = VSTXTBCOLR(WHITE)

    * assign memvars

    m_lat       = LAT
    m_ns        = N_S
    m_long      = LONG
    m_we        = W_E
    m_city      = CITY
    m_country   = COUNTRY
    m_timezone  = TIMEZONE
    m_telcode   = TELCODE
    m_pop       = POPULATION

    timesign = IF(m_timezone > 0, "+", "")

    * display database details line after line

    VSAY_AT(rec_x, rec_y,             m_city)
    VSAY_AT(rec_x, VROW()+textheight, TRANSFORM(m_pop, "@B######"))
    VSAY_AT(rec_x, VROW()+textheight, TRANSFORM(m_lat, "@B###.##"))
    VSAY_AT(VCOL()+textwidth, VROW(), m_ns)
    VSAY_AT(rec_x, VROW()+textheight, TRANSFORM(m_long, "@B###.##"))
    VSAY_AT(VCOL()+textwidth, VROW(), m_we)
    VSAY_AT(rec_x, VROW()+textheight, m_country)
    VSAY_AT(rec_x, VROW()+textheight, timesign+TRANSFORM(m_timezone, "@B###.##"))
    VSAY_AT(rec_x, VROW()+textheight, m_telcode)

    * set text background colour to previous

    VSTXTBCOLR(oldcolour)

    DisplayLoc()


RETURN(0)

********
** Function : DisplayPrm
********
FUNCTION DisplayPrm

    PRIVATE textheight, textwidth, oldcolour

    * get values once for speed

    textheight = VTHEIGHT()
    textwidth  = VTWIDTH()

    * set text colour

    oldcolour = VSTXTCOLR(BLUE)

    * display database prompts line after line

    VSAY_AT(prm_x, prm_y,             "City       :")
    VSAY_AT(prm_x, VROW()+textheight, "Population :")
    VSAY_AT(prm_x, VROW()+textheight, "Latitude   :")
    VSAY_AT(prm_x, VROW()+textheight, "Longitude  :")
    VSAY_AT(prm_x, VROW()+textheight, "Country    :")
    VSAY_AT(prm_x, VROW()+textheight, "Timezone   :")
    VSAY_AT(prm_x, VROW()+textheight, "Dial Code  :")

    * set text to previous colour

    VSTXTCOLR(oldcolour)

RETURN(0)


********
** Function : FirstRec
********
FUNCTION FirstRec

    GOTO TOP
    DisplayRec()

RETURN(0)


********
** Function : PrevRec
********
FUNCTION PrevRec

    SKIP -1
    DisplayRec()

RETURN(0)


********
** Function : NextRec
********
FUNCTION NextRec

    SKIP +1
    IF EOF()
        SKIP -1
    ENDIF
    DisplayRec()

RETURN(0)


********
** Function : EndRec
********
FUNCTION EndRec

    GOTO BOTTOM
    DisplayRec()

RETURN(0)


********
** Function : FindRec
********
FUNCTION FindRec

RETURN(0)


********
** Function : DisplayScr
********
FUNCTION DisplayScr

    PRIVATE logo, filehandle, checksize
    logo = SPACE(17168)


    * draw logo
    IF FILE("gforce.bmp")
        filehandle = FOPEN("gforce.bmp")
        checksize = FREAD(filehandle, @logo, 17168)
        FCLOSE(filehandle)
        IF checksize <> 17168
            VSAY_AT(messg_x, messg_y, "Error reading file")
            TONE(700, 5)
            TONE(700, 5)
        ENDIF
        VDRAWBMP(88, 5, 464, 37, logo)
    ENDIF

    * quit button
    oldcolour = VSBUTTCOLR(RED)
    VADDBUTTON(x, y, dx, dy, "QUIT", ESC)
    VSBUTTCOLR(oldcolour)

    * first record button
    VADDBUTTON(x+1*spacer, y, dx, dy, "", HOME)

    * previous button
    VADDBUTTON(x+2*spacer, y, dx, dy, "", CURSLEFT)

    * next button
    VADDBUTTON(x+3*spacer, y, dx, dy, "", CURSRIGHT)

    * last record button
    VADDBUTTON(x+4*spacer, y, dx, dy, "", END)

    * lookup record button
    VADDBUTTON(x+5*spacer, y, dx, dy, "?", ASC("?"))

    * draw raised shadow frame around buttons
    VRFRAME(display_x, y-4, 629, dy+8)

    * draw sunken shadow frame around display area
    VSFRAME(display_x, display_y, display_dx, display_dy)

    * draw image display area
    VSFRAME(image_x-3, image_y-3, image_dx+6, image_dy+6)
    VFRECT(image_x, image_y, image_dx, image_dy, BTWHITE)

    * draw record display area
    VSFRAME(image_x-3, image_y+image_dy+8, image_dx+6, VTHEIGHT()*8)

    * add a invisible button behind it to capture clicks
    oldtype = VSBUTTTYPE(4)
    VADDBUTTON(image_x, image_y, image_dx, image_dy, "", POINT)
    VSBUTTTYPE(oldtype)

    DispMap()

RETURN(0)

********
** Function : DispMap
********
FUNCTION DispMap

    PRIVATE mapbuffer
    mapbuffer = SPACE(64800)

    IF FILE("map.bmp")
        filehandle = FOPEN("map.bmp")
        checksize = FREAD(filehandle, @mapbuffer, 64800)
        FCLOSE(filehandle)
        IF checksize <> 64800
            VSAY_AT(messg_x, messg_y, "Error reading file")
            TONE(700, 5)
            TONE(700, 5)
        ENDIF
        VDRAWBMP(image_x, image_y, 360, 180, mapbuffer)
    ENDIF

RETURN(0)

********
** Function : QuitOut
********
FUNCTION QuitOut

    VSAY_AT(messg_x, messg_y, "Are you sure you want to quit y/n")

    key = VINKEY()

    IF key = ASC("y") .OR. key = ASC("Y")
        * close eveything - quit does it anyway!
        CLOSE ALL
        * give dos a cursor
        SET CURSOR ON
        * reset mouse otherwise you will get a mouse in dos
        MSE_RSET()
        * reset the video mode
        VMODE(3)

TEXT
This was a demonstration of Calypso Software's Clipper graphics libraries,
three libraries are currently developed:

    'DVIDEO'        Controls the Digithurst MicroEye PB video and compression
                    card allowing composite and RGB video signals to be
                    displayed, stored and recalled by a Clipper application.

    'GFORCE'        Provides Clipper with complete control in graphics mode on
                    VGA/SVGA equipped computers. Many Clipper commands
                    have been re-written to work in graphics mode along with
                    new functions previously unthinkable. The pushbutton
                    interface that you have just been using is part of the
                    GFORCE library!

    'GFILE'         Display and print all of the popular graphics file formats
                    PCX, BMP, GIFF, TIFF, TARGA, EPSF, MACPAINT & IMG, with
                    support for FX80, LASERJET and POSTSCRIPT printers.
Ŀ
                Get in touch with Calypso Software Limited                   
                     To find your nearest distributor!                       
                                                                             
                                               Contact   : Carl Clarke       
                                               Tel & Fax : (UK)  0923 720788 

Hit any key to continue...
ENDTEXT
        Tone(300, 1)
        Tone(499, 5)
        Tone(700, 5)
        INKEY(0)
        CLEAR
        * quit from clipper
        QUIT
    ELSE
        VSAY_AT(messg_x, messg_y, "                                   ")
    ENDIF

RETURN(0)

********
** Function : Calypso
********
FUNCTION Calypso

    PRIVATE calypsobmp, calypsopal, i, j
    calypsobmp = SPACE(64000)
    calypsopal = SPACE(768)

    IF FILE("calypso.pal")
        filehandle = FOPEN("calypso.pal")
        checksize = FREAD(filehandle, @calypsopal, 768)
        FCLOSE(filehandle)
        IF checksize <> 768
            TONE(700, 5)
            TONE(700, 5)
        ENDIF
    ENDIF

    IF FILE("calypso.bmp")
        filehandle = FOPEN("calypso.bmp")
        checksize = FREAD(filehandle, @calypsobmp, 64000)
        FCLOSE(filehandle)
        IF checksize <> 64000
            TONE(700, 5)
            TONE(700, 5)
        ENDIF
        VBLAST19(calypsobmp, calypsopal)
    ENDIF

    MSE_ON()

    VADDBUTTON(120, 170, 80, 20, "CONTINUE", 0)

    VINKEY()

    VRESBUTTON()

    MSE_OFF()

    VRESETPAL()

RETURN(0)


********
** Function : Helpex
********
FUNCTION Helpex

    PRIVATE textwidth, textheight
    textwidth = VTWIDTH()
    textheight = VTHEIGHT()

    VSFRAME(help_x, help_y, help_dx, help_dy)
    VSAY_AT(help_x+textwidth, help_y+textheight/2, " Help ")
    VSAY_AT(help_x+textwidth, VROW()+textheight,   "                            ")
    VSAY_AT(help_x+textwidth, VROW()+textheight,   "Button  Key    Effect       ")
    VSAY_AT(help_x+textwidth, VROW()+textheight,   "     End    Last Record  ")
    VSAY_AT(help_x+textwidth, VROW()+textheight,   "     Home   First Record ")
    VSAY_AT(help_x+textwidth, VROW()+textheight,   "       ->     Next Record  ")
    VSAY_AT(help_x+textwidth, VROW()+textheight,   "       <-     Prev Record  ")
    VSAY_AT(help_x+textwidth, VROW()+textheight,   "?       ?      Look up city ")
    VSAY_AT(help_x+textwidth, VROW()+textheight,   "QUIT    Esc    Quit program ")
    VSAY_AT(help_x+textwidth, VROW()+textheight,   "                        ")
    VSAY_AT(help_x+textwidth, VROW()+textheight,   "Click left button on the map")
    VSAY_AT(help_x+textwidth, VROW()+textheight,   "to locate the nearest city. ")
    VSAY_AT(help_x+textwidth, VROW()+textheight,   "Cities are found by quadrant")
    VSAY_AT(help_x+textwidth, VROW()+textheight,   "and then by longitude and   ")
    VSAY_AT(help_x+textwidth, VROW()+textheight,   "latitude.                   ")
    VSAY_AT(help_x+textwidth, VROW()+textheight,   "")
    VSAY_AT(help_x+textwidth, VROW()+textheight,   "")
    VSAY_AT(help_x+textwidth, VROW()+textheight,   "")
    VSAY_AT(help_x+textwidth, VROW()+textheight,   "  Hit any key to continue.  ")


    VINKEY()

    VCLEARSCR(help_x, help_y, help_dx, help_dy)



RETURN(0)


